---
title: FileSystemEntry.getParent()
slug: Web/API/FileSystemEntry/getParent
tags:
  - API
  - File System API
  - File and Directory Entry API
  - FileSystemEntry
  - Files
  - Method
  - Non-standard
  - Reference
  - getParent
---
<p>{{APIRef("File System API")}}{{SeeCompatTable}}</p>

<p><span class="seoSummary">The {{domxref("FileSystemEntry")}} interface's method <code><strong>getParent</strong></code><strong><code>()</code></strong> obtains a {{domxref("FileSystemDirectoryEntry")}}.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>FileSystemEntry</em>.getParent(<em>successCallback</em>[, <em>errorCallback</em>]);</pre>

<h3 class="syntaxbox" id="Parameters">Parameters</h3>

<dl>
 <dt><code>successCallback</code></dt>
 <dd>A function which is called when the parent directory entry has been retrieved. The callback receives a single input parameter: a {{domxref("FileSystemDirectoryEntry")}} object representing the parent directory. The parent of the root directory is considered to be the root directory, itself, so be sure to watch for that.</dd>
 <dt><code>errorCallback</code> {{optional_inline}}</dt>
 <dd>An optional callback which is executed if an error occurs. There's a single parameter: a {{domxref("FileError")}} describing what went wrong.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}.</p>

<h3 id="Errors">Errors</h3>

<dl>
 <dt><code>FileError.INVALID_STATE_ERR</code></dt>
 <dd>The operation failed because the file system's state doesn't permit it. This can happen, for example, if the file system's cached state differs from the actual state of the file system.</dd>
 <dt><code>FileError.NOT_FOUND_ERR</code></dt>
 <dd>The specified path could not be found.</dd>
 <dt><code>FileError.SECURITY_ERR</code></dt>
 <dd>Security restrictions prohibit obtaining the parent directory's information.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>This example renames  the file specified by the variable <code>fileEntry</code> to <code>"newname.html"</code>.</p>

<pre class="brush: js">fileEntry.getParent(function(parent) {
  fileEntry.moveTo(parent, "newname.html", function(updatedEntry) {
    console.log("File " + fileEntry.name + " renamed to newname.html.");
  });
}, function(error) {
  console.error("An error occurred: Unable to rename " + fileEntry.name
        + " to newname.html.");
});</pre>

<p>This is accomplished by first obtaining a {{domxref("FileSystemDirectoryEntry")}} object representing the directory the file is currently located in. Then {{domxref("FileSystemEntry.moveTo", "moveTo()")}} is used to rename the file within that directory.</p>

<h2 id="Using_promises">Using promises</h2>

<p>Currently, there isn't a {{jsxref("Promise")}}-based version of this method. You can, however, create a simple helper function to adapt it, like this:</p>

<pre class="brush: js">function getParentPromise(entry) {
  return new Promise((resolve, reject) =&gt; {
    entry.getParent(resolve, reject);
  });
}</pre>

<p>A similar approach can be taken elsewhere in the File and Directory Entries API.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('File System API', '#dom-filesystementry-getparent', 'getParent()') }}</td>
   <td>{{ Spec2('File System API') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemEntry.getParent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a></li>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API/Introduction">Introduction to the File System API</a></li>
</ul>
